<?php

use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

$_REQUEST['commission_id'] = empty($_REQUEST['commission_id']) ? 0 : $_REQUEST['commission_id'];

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

	fn_trusted_vars('commission_data', 'commissions');
	$suffix = '';

	//
	// Update commission
	//
	if ($mode == 'update') {
		if (fn_allowed_for('ULTIMATE') && Registry::get('runtime.company_id')) {
			if (!empty($_REQUEST['commission_id']) && !fn_check_company_id('commissions', 'commission_id', $_REQUEST['commission_id'])) {
				fn_company_access_denied_notification();

				return array(CONTROLLER_STATUS_OK, 'switips.update?commission_id=' . $_REQUEST['commission_id']);
			}
			if (!empty($_REQUEST['commission_id'])) {
				unset($_REQUEST['commission_data']['company_id']);
			}
		}

		$commission_id = fn_update_switips_commission($_REQUEST['commission_data'], $_REQUEST['commission_id'], DESCR_SL);

		$suffix = ".update?commission_id=$commission_id";
	}

	//
	// Delete selected commissions
	//
	if ($mode == 'm_delete') {

		if (!empty($_REQUEST['commission_ids'])) {
			fn_delete_switips_commissions($_REQUEST['commission_ids']);
		}

		$suffix = ".manage";
	}

	if ($mode == 'delete') {

		if (!empty($_REQUEST['commission_id'])) {
			fn_delete_switips_commissions($_REQUEST['commission_id']);
		}

		$suffix = ".manage";
	}

	if ($mode === 'update_status') {
		if (!empty($_REQUEST['commission_ids'])) {
			foreach ($_REQUEST['commission_ids'] as $commission_id) {
				fn_tools_update_status([
					'table'             => 'switips_commissions',
					'status'            => $_REQUEST['status'],
					'id_name'           => 'commission_id',
					'id'                => $commission_id,
					'show_error_notice' => false
				]);
			}
		}

		return [CONTROLLER_STATUS_OK, $_REQUEST['redirect_url']];
	}

	return array(CONTROLLER_STATUS_OK, 'switips' . $suffix);
}

// ----------------------------- GET routines -------------------------------------------------

// commission data
if ($mode == 'update') {

	$tabs = [
		'details' => [
			'title' => __('general'),
			'href' => "switips.update?commission_id={$_REQUEST['commission_id']}&selected_section=details",
			'js' => true,
		],
		'conditions' => [
			'title' => __('conditions'),
			'href' => "switips.update?commission_id={$_REQUEST['commission_id']}&selected_section=conditions",
			'js' => true,
		]
	];


	Registry::set('navigation.tabs', $tabs);

	$commission_data = fn_get_switips_commission_data($_REQUEST['commission_id']);

	if (empty($commission_data)) {
		return array(CONTROLLER_STATUS_NO_PAGE);
	}

	Tygh::$app['view']->assign('commission_data', $commission_data);

	Tygh::$app['view']->assign('schema', fn_switips_commission_get_schema());

	// Add commission
} elseif ($mode == 'add') {

	$tabs = [
		'details' => [
			'title' => __('general'),
			'href' => "switips.add?selected_section=details",
			'js' => true,
		],
		'conditions' => [
			'title' => __('conditions'),
			'href' => "switips.add?selected_section=conditions",
			'js' => true,
		],
	];


	Registry::set('navigation.tabs', $tabs);

	Tygh::$app['view']->assign('schema', fn_switips_commission_get_schema());

} elseif ($mode == 'dynamic') {
	Tygh::$app['view']->assign('schema', fn_switips_commission_get_schema());
	Tygh::$app['view']->assign('prefix', $_REQUEST['prefix']);
	Tygh::$app['view']->assign('elm_id', $_REQUEST['elm_id']);


	if (!empty($_REQUEST['condition'])) {
		Tygh::$app['view']->assign('condition_data', array('condition' => $_REQUEST['condition']));

	}


	// commissions list
} elseif ($mode == 'manage') {

	list($commissions, $search) = fn_get_switips_commissions($_REQUEST, Registry::get('settings.Appearance.admin_elements_per_page'), DESCR_SL);

	Tygh::$app['view']->assign('search', $search);
	Tygh::$app['view']->assign('commissions', $commissions);

} elseif ($mode == 'orders') {
	
	list($orders, $search) = fn_get_switips_orders($_REQUEST, Registry::get('settings.Appearance.admin_elements_per_page'), DESCR_SL);
	
	Tygh::$app['view']->assign('search', $search);
	Tygh::$app['view']->assign('orders', $orders);
	
}